#!/bin/sh

# parse_google_news.sh - Get the news from google and make an 
# audio file.
#
# Jeremy English jhe@jeremyenglish.org


date=`date`

news_folder=/home/julie/.audio_news
news_wave=$news_folder/news.wav
date +%Y%m%d%H%M > /tmp/un
unique=`cat /tmp/un`
upload_mp3="$unique"_markov_news.mp3
news_mp3=$news_folder/$upload_mp3
news_rss=$news_folder/markov_news.xml

#save the unique info for the other scripts
echo $upload_mp3 > $news_folder/markov_unique

talk="/home/julie/festival/festival/bin/text2wave -o $news_wave "

#get the news from google
#links -no-numbering -dump http://news.google.com/news?ned=tus > /tmp/news
news_file=/tmp/news

#parse the file
end=`grep -ni "international versions of google news" $news_file \
    | awk '{print $1 }' | sed s/://`

try=1
timeout=0
while [ $try -eq 1 ]
do
	cat $news_file | sed $end,'$d' |sed '1,12d' | more | egrep -v ">> *$" \
    		| egrep -v "(Jump to:|Sports \|)" | egrep -v "^.+-.+-.+$" | sed s/\*//g \
   		| /home/julie/markov | fmt | $talk

	#  text2wave has a hard time cleaning up after itself.
	# So we need this code to check the return status of text2wave. If it fails
         # we will try to delete the tmp files are selfs and try again.
	# If we timeout then there is no point in the rest of the script executing.
	# We exit with a status of 1

	case $? in
		0) try=0   ;; 
		*) timeout=$(($timeout+1)); echo "Try Again..."; rm -f /tmp/est*; sleep 2 ;;
	esac 

	case $timeout in
		10) echo 'Timed out trying to create wave file'; exit 1 ;;
	esac
done

$news_folder/wav2mp3.sh "Markov Google News $date" "Markov Google News" $news_wave $news_mp3

file_length=`ls -l $news_mp3 | awk '{print $5}'`

$news_folder/make_rss.sh $news_rss \
	"Google News ran through a Markov chain algorithm. Sometimes it's funny. " \
	"Markov News"\
	$upload_mp3\
	$file_length

exit 0