#!/bin/sh
#
# Lets see if we can create the podcast and get them to the server.
#
# Jeremy English

wrk_fld=/home/julie/.audio_news

log_file=/tmp/podcast_news.log

# Generate the podcast.
# Markov news does not pull it own copy of google news. 
# So the order here is important.

$wrk_fld/parse_google_news.sh > $log_file 2>&1
if [ $? -ne 0 ]
then
	echo 'parse_google_news.sh failed' >> $log_file 2>&1
	exit 1
fi
sleep 10


$wrk_fld/markov_news.sh  >> $log_file 2>&1
if [ $? -ne 0 ]
then
	echo 'markov_news.sh failed' >> $log_file 2>&1
	exit 1
fi
sleep 10

# My Clean up script needs some work.
# I might have it run in its own cron job that cleans up the old mp3 files
# once a day.
# Delete the old podcast
#echo "Delete the old podcast" >> $log_file 2>&1
#$wrk_fld/clean_ftp_news.pl >> $log_file 2>&1


# We also want to upload a new copy of the index.html file. It should have
# links to the mp3 files that we just created.
$wrk_fld/make_html.pl >> $log_file 2>&1

$wrk_fld/put_files.pl `cat $wrk_fld/news_unique` `cat $wrk_fld/markov_unique` >> $log_file 2>&1

# I don't know why the website is tacking the content type to
# the top of the text files that I upload through the web interface
# using Mechanize.  So we are going to send the xml and html files 
# using ftp. The files are small so they shouldn't hang like the mp3 
# files where doing.

try=1
timeout=0
while [ $try -eq 1 ]
do
	$wrk_fld/put_xml.pl >> $log_file 2>&1
	case $? in
		0) try=0   ;; 
		*) timeout=$(($timeout+1)); echo "Try Again..." >> $log_file 2>&1 ; sleep 30 ;;
	esac
done 

#remove local copy
echo "Removing files"  >> $log_file 2>&1
rm /home/julie/.audio_news/*.wav
rm /home/julie/.audio_news/*.mp3
rm /home/julie/.audio_news/*.xml
